// Copyright (C) 2023, Jakob Wakeling
// All rights reserved.

#include "bltn.h"
#include "util/util.h"

#include <stdio.h>

extern const char *const version; /* main.c */
extern bool _loop; /* main.c */
extern s32 _ret; /* exec.c */

static int bltn_exit(int, char *[]) { _loop = false; return 0; }
static int bltn_false(int, char *[]) { return 1; }
static int bltn_help(int, char *[]) { fputs(version, stdout); return 0; }
static int bltn_true(int, char *[]) { return 0; }

extern int bltn_cd(int, char *[]);
extern int bltn_eval(int, char *[]);

static int getret(int, char *[]) { printf("%d\n", _ret); return 0; }

bltn bltns[] = {
	{ "cd",    &bltn_cd    },
	{ "eval",  &bltn_eval  },
	{ "exit",  &bltn_exit  },
	{ "false", &bltn_false },
	{ "help",  &bltn_help  },
	{ "true",  &bltn_true  },
	{ "ret",   &getret     },
	{ NULL, NULL }
};
